--------------------------------
-- HIGHLANDER / HOGS OF WAR
-- version 0.1
-- by mikade
--------------------------------

-- other ideas
--

-- circles to mark hogs with more than 4 weapons
-- health crate and switch drops
-- hogs start with 1 weap and 1 utility each (some are rarer than others?)
-- resurrecting, how does that work?
-- check what happens when you kill yourself, etc. kamikaze njalo


-- could always create a "donor card" mini circle instead of automatic disposal


-----------------





loadfile(GetDataPath() .. "Scripts/Locale.lua")()
loadfile(GetDataPath() .. "Scripts/Tracker.lua")()

local wepArray = {}
local wepArrayCount = 0

local atkArray = {}
local atkCount = 0

local utilArray = {}
local utilArrayCount = 0

local currName
local lastName
local started = false
local switchStage = 0

function StartingSetUp(gear)

	--[[setGearValue(gear,amBazooka,2)
	setGearValue(gear,amGrenade,100)
	setGearValue(gear,amRope,100)
	setGearValue(gear,amBlowTorch,0)
	setGearValue(gear,amParachute,3)]]


	--[[for i = 0, (wepArrayCount-1) do
		setGearValue(gear,wepArray[i],0)
	end

	i = GetRandom(wepArrayCount)
	setGearValue(gear,wepArray[i],100)

	SetHealth(gear, 30)
	]]


	for i = 0, (wepArrayCount-1) do
		setGearValue(gear,wepArray[i],0)
	end


	--i = GetRandom(atkArrayCount)
	--setGearValue(gear,wepArray[i],1)	

	i = GetRandom(atkArrayCount)
	setGearValue(gear,atkArray[i],1)

	i = GetRandom(utilArrayCount)
	setGearValue(gear,utilArray[i],1)

	SetHealth(gear, 100)

end

function ConvertValues(gear)

	for i = 0, (wepArrayCount-1) do
		AddAmmo(gear, wepArray[i], getGearValue(gear,wepArray[i]) )
	end

	--AddAmmo(gear, amBazooka, getGearValue(gear,amBazooka) )

end


function TransferWeps(gear)

	if CurrentHedgehog ~= nil then

		for i = 0, (wepArrayCount-1) do
			val = getGearValue(gear,wepArray[i])
			if val ~= 0 then
				setGearValue(CurrentHedgehog, wepArray[i], val)
				AddAmmo(CurrentHedgehog, wepArray[i], val)
			end
		end

	end

end

--function onPrecise()
--end

function onGameInit()
	GameFlags = gfInfAttack
	TurnTime = 90000
end

function onGameStart()


	ShowMission	(
				loc("HIGHLANDER"),
				loc("Not all hogs are born equal."),

				"- " .. loc("Eliminate enemy hogs and take their weapons.") .. "|" ..
				"- " .. loc("Per-Hog Ammo") .. "|" ..
				"- " .. loc("Weapons reset.") .. "|" ..
				"- " .. loc("Unlimited Attacks") .. "|" ..
				"", 4, 4000
				)

	atkArray[0] = amBazooka
	atkArray[1] = amBee
	atkArray[2] = amMortar
	atkArray[3] = amDrill
	atkArray[4] = amSnowball --- this right?

	atkArray[5] = amGrenade
	atkArray[6] = amClusterBomb
	atkArray[7] = amMolotov
	atkArray[8] = amWatermelon
	atkArray[9] = amHellishBomb
	atkArray[10] = amGasBomb

	atkArray[11] = amShotgun
	atkArray[12] = amDEagle
	atkArray[13] = amFlamethrower
	atkArray[14] = amSniperRifle
	atkArray[15] = amSineGun

	atkArray[16] = amFirePunch
	atkArray[17] = amWhip
	atkArray[18] = amBaseballBat
	atkArray[19] = amKamikaze
	atkArray[20] = amSeduction
	atkArray[21] = amHammer

	atkArray[22] = amMine
	atkArray[23] = amDynamite
	atkArray[24] = amCake
	atkArray[25] = amBallgun
	atkArray[26] = amRCPlane
	atkArray[27] = amSMine

	atkArray[28] = amAirAttack
	atkArray[29] = amMineStrike
	atkArray[30] = amDrillStrike
	atkArray[31] = amNapalm
	atkArray[32] = amPiano

	atkArray[33] = amBirdy
	atkArray[34] = amLandGun

	atkArrayCount = 35

	-------------------------------


	wepArray[0] = amBazooka
	wepArray[1] = amBee
	wepArray[2] = amMortar
	wepArray[3] = amDrill
	wepArray[4] = amSnowball --- this right?

	wepArray[5] = amGrenade
	wepArray[6] = amClusterBomb
	wepArray[7] = amMolotov
	wepArray[8] = amWatermelon
	wepArray[9] = amHellishBomb
	wepArray[10] = amGasBomb

	wepArray[11] = amShotgun
	wepArray[12] = amDEagle
	wepArray[13] = amFlamethrower
	wepArray[14] = amSniperRifle
	wepArray[15] = amSineGun

	wepArray[16] = amFirePunch
	wepArray[17] = amWhip
	wepArray[18] = amBaseballBat
	wepArray[19] = amKamikaze
	wepArray[20] = amSeduction
	wepArray[21] = amHammer

	wepArray[22] = amMine
	wepArray[23] = amDynamite
	wepArray[24] = amCake
	wepArray[25] = amBallgun
	wepArray[26] = amRCPlane
	wepArray[27] = amSMine

	wepArray[28] = amAirAttack
	wepArray[29] = amMineStrike
	wepArray[30] = amDrillStrike
	wepArray[31] = amNapalm
	wepArray[32] = amPiano

	wepArray[33] = amBirdy
	wepArray[34] = amLandGun

	wepArray[35] = amBlowTorch
	wepArray[36] = amPickHammer
	wepArray[37] = amGirder
	wepArray[38] = amPortalGun

	wepArray[39] = amRope
	wepArray[40] = amParachute
	wepArray[41] = amTeleport
	wepArray[42] = amJetpack

	wepArray[43] = amInvulnerable
	wepArray[44] = amLaserSight
	wepArray[45] = amVampiric
	wepArray[46] = amResurrector

	wepArray[47] = amLowGravity
	wepArray[48] = amExtraDamage
	wepArray[49] = amExtraTime

	wepArray[50] = amTardis

	--[[wepArray[47] = amBazooka
	wepArray[48] = amBazooka	
	wepArray[49] = amExtraTime
	wepArray[50] = amBazooka]]

	wepArrayCount = 51 --50 -- cant go higher than 48?

	----------------------------

	utilArray[0] = amBlowTorch
	utilArray[1] = amPickHammer
	utilArray[2] = amGirder
	utilArray[3] = amPortalGun

	utilArray[4] = amRope
	utilArray[5] = amParachute
	utilArray[6] = amTeleport
	utilArray[7] = amJetpack

	utilArray[8] = amInvulnerable
	utilArray[9] = amLaserSight
	utilArray[10] = amVampiric
	utilArray[11] = amResurrector

	utilArray[12] = amLowGravity
	utilArray[13] = amExtraDamage
	utilArray[14] = amExtraTime

	utilArray[15] = amTardis

	utilArrayCount = 16

	runOnGears(StartingSetUp)
	runOnGears(ConvertValues)


end

function onNewTurn()
--
end


function onGameTick()

	if (CurrentHedgehog ~= nil) then

		currName = GetHogName(CurrentHedgehog)

		if (currName ~= lastName) then
			AddCaption(loc("Switched to ") .. currName .. "!")
			ConvertValues(CurrentHedgehog)
		end

		lastName = currName
	end

end



function onGearAdd(gear)

	if GetGearType(gear) == gtHedgehog then
		trackGear(gear)
	end

end

function onGearDelete(gear)

	if GetGearType(gear) == gtHedgehog then
		TransferWeps(gear)
		trackDeletion(gear)
	end

end

function onAmmoStoreInit()
	SetAmmo(amSkip, 9, 0, 0, 0)
	SetAmmo(amSwitch, 1, 0, 0, 0)
	--SetAmmo(amJetpack, 9, 0, 0, 0)
end

